#include <graphics.h>
#include <bios.h>
#include <stdlib.h>
#include <conio.h>
#include <iostream.h>
#include <math.h>
#include <fstream.h>
#include <string.h>
#include <ctype.h>
#include <dos.h>
#include <dir.h>

#define RIGHT 77      //scan-kod strelki vpravo
#define LEFT 75       //scan-kod strelki vlevo
#define UP 72         //scan-kod strelki vverh
#define DOWN 80       //scan-kod strelki vpravo
#define ENTER '\15'   //ASCII-kod klavishi Enter


float pi=4*atan(1);

void arrows2 (int, char, float*, float*);
void prfile (char*);


int maxx, maxy, num, n, ns, nb, k, t;
ofstream wrt;
ifstream rd;
char pfile[13];


void redtown(void);
void redsvet(void);
void redsvet2(float, float, int);
void redroad(void);
void redavto(void);
void redbenzin(void);
void loadtown(void);
void town(void);
void skor1(void);
void police1(void);
void remont1(void);
void drawtown(void);
void svetofor(void);
void drawsvet(void);


class CBenzin
{
	private:
		float benz;
	public:
		float x;
		float y;
		float x1;
		float y1;
		CBenzin(){};
		void zapravka (void);
};

class CTraffic
{
	public:
		int svet1;
		int svet2;
		float x;
		float y;
		CTraffic(){};
};

class CRoad
{
	private:
		int formula;
		float a;
		float b;
		float c;
		double n;
		int col;
		float t1;
		char filename[13];
	public:
//		void(*form[6])(void);
		int nom;
		CRoad(){};
//		CRoad(int);
		void draw (void);
		void priam(void);
		void parab(void);
		void giperb(void);
		void sinus(void);
		void lemni(void);
		void def(void);
		void drawroad(void);
		void priam1(void);
		void parab1(void);
		void giperb1(void);
		void sinus1(void);
		void lemni1(void);
		void def1(void);
		void cursor(void);
		friend void savetown (void);
		void loadroad (void);
};


class CAvto
{
	public:
		float x;
		float y;
		float poli[30];
		int col;
		int col2;
		float vx;
		float vy;
		int benzin;
		int vmax;
		int type;
		char name[10];
		int nom;
		int stop;
		char filename[13];
		void* image;
		CAvto(){};
		void draw (void);
		void pic (void);
		void savepic (void);
		void loadpic (void);
		void drawavto (void);
		void dvizhok (void);
		void createmash (void);
		void save (void);
		void load (void);
};

void svet3 (int);
CTraffic svet[100];
CBenzin benz1[5];
CRoad road[10];
CAvto skor;
CAvto police;
CAvto remont;
CAvto mash[7];


void main(void)
{
	int gdriver=DETECT, gmode;     //inicializacia graficheskogo regima
	initgraph(&gdriver, &gmode, "d:\\Borland\\BC3_1\\BGI"); //podkluchenie grafichesko regima
	maxx=getmaxx();
	maxy=getmaxy();
	redtown();
	redavto();
	cleardevice();
	town();
}

void redtown(void)
{
	cout<<"Do you want to draw road(d) or load saved road(l)";
	while (1)
	{
		switch (getch())
		{
			case 'D':
			case 'd':
				k=1;
				t=1;
				ns=0;
				redroad();
				cleardevice();
				gotoxy (1, 1);
				drawtown ();
//				redsvet();
//				redbenzin();
				savetown ();
				break;
			case 'l':
			case 'L':
				loadtown();
				break;
			default:
				continue;
		}
		break;
	}
}


void redbenzin (void)
{
	char as;
	int but, sc, c;
	cout<<"vvedite chislo benzokolonok\n";
	cin>>nb;
	for (int i=0; i<nb; i++)
	{
		do
		{
			but=bioskey(0);
			sc=but>>8;
			as=but&0x00FF;
			putpixel (benz1[i].x, benz1[i].y, 0);
			arrows2 (sc, as, &benz1[i].x, &benz1[i].y);
			putpixel (benz1[i].x, benz1[i].y, 15);
		}
		while (as!=ENTER);
		setfillstyle (SOLID_FILL, 7);
		bar (benz1[i].x-10, benz1[i].y-7, benz1[i].x+10, benz1[i].y+7);
	}
	setcolor (4);
	cout<<"rasstavte povoroty na benzokolonki";
	for (i=0; i<nb; i++)
	{
		benz1[i].x1=maxx/2;
		benz1[i].y1=15;
		c=getpixel (benz1[i].x1, benz1[i].y1);
		putpixel (benz1[i].x1, benz1[i].y1, 15);
		do
		{
			but=bioskey(0);
			sc=but>>8;
			as=but&0x00FF;
			putpixel (benz1[i].x1, benz1[i].y1, 0);
			arrows2 (sc, as, &benz1[i].x1, &benz1[i].y1);
			c=getpixel (benz1[i].x1, benz1[i].y1);
			putpixel (benz1[i].x1, benz1[i].y1, 15);
		}
		while (as!=ENTER);
		setfillstyle (SOLID_FILL, 7);
		if (c==0)
			i--;
		else
			line (benz1[i].x, benz1[i].y, benz1[i].x1, benz1[i].y1);
	}
}



void loadtown (void)
{
	char pfile3[40];
	struct ffblk f;
	int k=-1, i;
	cout<<"\ninput filename\n";
	while (1)
	{
		cin>>pfile3;
		k=findfirst(pfile3, &f, FA_ARCH);       //naiti file s vvedennym imenem
		if (!k)
			break;
		cout<<"such a file is absent\n";
	}
	strcpy (pfile, pfile3);
	rd.open (pfile);
	rd>>num;
	for (i=0; i<num; i++)
	{
		road[i].loadroad();
	}
	rd>>ns;
	for (i=0; i<ns; i++)
	{
		rd>>svet[i].svet1;
		rd>>svet[i].x;
		rd>>svet[i].y;
	}
	rd.close();
}

void CRoad::loadroad (void)
{
	rd>>formula;
	rd>>a;
	rd>>b;
	rd>>c;
	rd>>n;
	rd>>t;
	rd>>col;
	if (formula==5)
		rd>>filename;
}



void redroad (void)
{
	cout<<"insert number of roads, menshe 10 ";
	cin>>num;
	cleardevice();
	gotoxy (1, 1);
	cout<<"vvodite koefficienty k formulam. Kogda dorogi vam nraviatsia, tknite 'y'";
	for (int i=0; i<num; i++)
	{
		setfillstyle (SOLID_FILL, 0);
		bar (0, maxy-95, maxx, maxy);
		setcolor (WHITE);
		outtextxy(20, maxy-40, "priamaia");
		outtextxy(20, maxy-25, "parabola");
		outtextxy(20, maxy-10, "krug");
		outtextxy(150, maxy-40, "sinusoida");
		outtextxy(150, maxy-25, "lemniskata");
		outtextxy(150, maxy-10, "drugoe");
		road[i].nom=i;
		road[i].draw();
	}
}

void redsvet (void)
{
	cout<<"vvedite chislo svetoforov";
	cin>>ns;
	void *image1;
	unsigned int size;
	int but, sc;
	char as;
	size=imagesize(1, 1, 7, 7);    //rasmer kursora
	image1=malloc(size);
	for (int i=0; i<ns; i++)
	{
		svet[i].x=10;
		svet[i].y=10;
		getimage (svet[i].x-3, svet[i].y-3, svet[i].x+3, svet[i].y+3, image1);
		setfillstyle (SOLID_FILL, DARKGRAY);
		do
		{
			but=bioskey(0);
			sc=but>>8;
			as=but&0x00FF;
			setcolor (0);
			circle (svet[i].x, svet[i].y, 2);
			putimage (svet[i].x-3, svet[i].y-3, image1, COPY_PUT);
			arrows2 (sc, as, &svet[i].x, &svet[i].y);
			getimage (svet[i].x-3, svet[i].y-3, svet[i].x+3, svet[i].y+3, image1);
			setcolor (15);
			circle (svet[i].x, svet[i].y, 2);
		}
		while (as!=ENTER);
		putimage (svet[i].x-3, svet[i].y-3, image1, COPY_PUT);
		svet[i].svet1=getpixel (svet[i].x, svet[i].y);
		if (svet[i].svet1==0)
		{
			i--;
			continue;
		}
		setcolor (4);
		line (svet[i].x, svet[i].y, i*15+10, maxy-85);
		bar (i*15+10, maxy-95, i*15+20, maxy-75);
	}
}


/*CRoad::CRoad(int k)
{
	(*form[0])()=&CRoad::priam;
	(*form[1])()=&CRoad::parab;
	(*form[2])()=&CRoad::giperb;
	(*form[3])()=&CRoad::sinus;
	(*form[4])()=&CRoad::lemni;
	(*form[5])()=&CRoad::defaultf;
} */

void CRoad::draw(void)
{
	cursor();
	setfillstyle(SOLID_FILL, 0);
	bar(0, maxy-95, maxx, maxy);
	cleardevice();
	switch (formula)
	{
		case 0:
			priam();
			break;
		case 1:
			parab();
			break;
		case 2:
			giperb();
			break;
		case 3:
			sinus();
			break;
		case 4:
			lemni();
			break;
		case 5:
			def();
			break;
	}
}


void CRoad::priam(void)
{
	float x, y;
	a=1;
	char as;
	int sc, but;
	b=0;
	col=nom+1;
	if (col>=4)
		col++;
	if (col>=7)
		col++;
	do
	{
		but=bioskey(0);
		as=but&0x00FF;
		setcolor (0);
		for (x=-maxx/2; x<maxx/2; x+=0.2)
		{
			y=a*x+b;
			rectangle (maxx/2+x, (maxy-95)/2-y, maxx/2+x+1, (maxy-95)/2-y-1);
		}
		switch(as)
		{
			case '\x0':
				switch(but>>8)
				{
					case LEFT:
					case UP:
						b+=5;
						break;
					case RIGHT:
					case DOWN:
						b-=5;
						break;
				}
				break;
			case '+':
				a++;
				break;
			case '-':
				a=a/2;
				break;
			case 'n':
				a=-a;
				break;
			default:
				break;
		}
		setcolor (col);
		for (x=-maxx/2; x<maxx/2; x+=0.2)
		{
			y=a*x+b;
			rectangle (maxx/2+x, (maxy-95)/2-y, maxx/2+x+1, (maxy-95)/2-y-1);
		}
	}while (as!='y');
}

void CRoad::parab(void)
{
	double x, y;
	a=1;
	char as;
	int sc, but;
	col=nom+1;
	if (col>=4)
		col++;
	if (col>=7)
		col++;
	do
	{
		but=bioskey(0);
		as=but&0x00FF;
		setcolor (0);
		for (x=-maxx/2; x<maxx/2; x+=0.2)
		{
			y=a*(b+x)*(b+x)+c;
			rectangle (maxx/2+x, (maxy-95)/2-y/4, maxx/2+x+1, (maxy-95)/8-y/2-1);
		}
		switch(as)
		{
			case '\x0':
				switch(but>>8)
				{
					case LEFT:
						b-=5;
						break;
					case UP:
						c+=5;
						break;
					case RIGHT:
						b-=5;
						break;
					case DOWN:
						c-=5;
						break;
				}
				break;
			case '+':
				a++;
				break;
			case '-':
				a=a/2;
				break;
			case 'n':
				a=-a;
				break;
			default:
				break;
		}
		setcolor (col);
		for (x=-maxx/2; x<maxx/2; x+=0.2)
		{
			y=a*(x+b)*(x+b)+c;
			rectangle (maxx/2+x, (maxy-95)/2-y/4, maxx/2+x+1, (maxy-95)/2-y/4-1);
		}
	}
	while (as!='y');
}

void CRoad::giperb(void)
{
	float x, y;
	char as;
	int sc, but;
	col=nom+1;
	if (col>=4)
		col++;
	if (col>=7)
		col++;
	c=15;
	do
	{
		setfillstyle (SOLID_FILL, 0);
		but=bioskey(0);
		as=but&0x00FF;
		setcolor (0);
		for (x=-c; x<c; x+=0.2)
		{
			y=sqrt(c*c-x*x);
			rectangle (maxx/2+x+a, (maxy-95)/2-y-b, maxx/2+x+a+1, (maxy-95)/2-y-1-b);
			y=-sqrt(c*c-x*x);
			rectangle (maxx/2+x+a, (maxy-95)/2-y-b, maxx/2+x+1+a, (maxy-95)/2-y-b-1);
		}
		bar (0, maxy-95, maxx, maxy);
		switch(as)
		{
			case '\x0':
				switch(but>>8)
				{
					case LEFT:
						a-=5;
						break;
					case UP:
						b+=5;
						break;
					case RIGHT:
						a+=5;
						break;
					case DOWN:
						b-=5;
						break;
				}
				break;
			case '+':
				c+=2;
				break;
			case '-':
				c-=2;
				break;
			default:
				break;
		}
		setcolor (col);
		for (x=-c; x<c; x+=0.2)
		{
			y=sqrt(c*c-x*x);
			rectangle (maxx/2+x+a, (maxy-95)/2-y-b, maxx/2+x+1+a, (maxy-95)/2-y-b-1);
			y=-sqrt(c*c-x*x);
			rectangle (maxx/2+x+a, (maxy-95)/2-y-b, maxx/2+x+1+a, (maxy-95)/2-y-b-1);
		}
	}
	while (as!='y');
}

void CRoad::sinus(void)
{
	double x, y;
	char as;
	int sc, but;
	col=nom+1;
	if (col>=4)
		col++;
	if (col>=7)
		col++;
	a=5;
	n=1;
	c=1;
	do
	{
		but=bioskey(0);
		as=but&0x00FF;
		setcolor (0);
		for (x=-maxx/2; x<maxx/2; x+=0.2)
		{
			y=a*sin(n*x+b)+c;
			rectangle (maxx/2+4*x, (maxy-95)/2-4*y, maxx/2+4*x+1, (maxy-95)/2-4*y-1);
		}
		switch(as)
		{
			case '\x0':
				switch(but>>8)
				{
					case LEFT:
						c+=5;
						break;
					case UP:
						b+=5;
						break;
					case RIGHT:
						c-=5;
						break;
					case DOWN:
						b-=5;
						break;
				}
				break;
			case '+':
				n++;
				break;
			case '-':
				n=n/2;
				break;
			case '*':
				a++;
				break;
			case '/':
				a=a/2;
				break;
			default:
				break;
		}
		setcolor (col);
		for (x=-maxx/2; x<maxx/2; x+=0.2)
		{
			y=a*sin(n*x+b)+c;
			rectangle (maxx/2+4*x, (maxy-95)/2-4*y, maxx/2+4*x+1, (maxy-95)/2-4*y-1);
		}
	}
	while (as!='y');
}

void CRoad::lemni(void)
{
	double x, y, t, r;
	char as;
	int sc, but;
	col=nom+1;
	if (col>=4)
		col++;
	if (col>=7)
		col++;
	a=5;
	n=1;
	c=1;
	do
	{
		setfillstyle (SOLID_FILL, 0);
		but=bioskey(0);
		as=but&0x00FF;
		setcolor(0);
		for (t=-0.785; t<0.785; t+=0.01)
		{
			r=a*sqrt(2*cos(2*t));
			x=r*cos(t);
			y=r*sin(t);
			rectangle (maxx/2+x+b, (maxy-95)/2-y-c, maxx/2+x+1+b, (maxy-95)/2-y-c-1);
			rectangle (maxx/2-x+b, (maxy-95)/2+y-c, maxx/2-x+1+b, (maxy-95)/2+y-c-1);
		}
		bar (0, maxy-95, maxx, maxy);
		switch(as)
		{
			case '\x0':
				switch(but>>8)
				{
					case LEFT:
						c+=5;
						break;
					case UP:
						b+=5;
						break;
					case RIGHT:
						c-=5;
						break;
					case DOWN:
						b-=5;
						break;
				}
				break;
			case '+':
				a+=2;
				break;
			case '-':
				a-=2;
				break;
			default:
				break;
		}
		setcolor (col);
		for (t=-0.785; t<0.785; t+=0.01)
		{
			r=a*sqrt(2*cos(2*t));
			x=r*cos(t);
			y=r*sin(t);
			rectangle (maxx/2+x+b, (maxy-95)/2-y-c, maxx/2+x+1+b, (maxy-95)/2-y-c-1);
			rectangle (maxx/2-x+b, (maxy-95)/2+y-c, maxx/2-x+1+b, (maxy-95)/2+y-c-1);
		}
	}
	while (as!='y');
}


void CRoad::cursor (void)
{
	setcolor(2);
	line(1, maxy-42, 15, maxy-38);
	line(15, maxy-38, 1, maxy-34);
	unsigned int size;
	void* image;
	size=imagesize(1, maxy-42, 15, maxy-34);
	image=malloc(size);
	getimage(1, maxy-42, 15, maxy-34, image);
	int but, scan, x, y=0;
	x=0;
	char as;
	do
	{
		but=bioskey(0);
		as=but&0x00FF;
		putimage (1+x*130, maxy-42+y*15, image, XOR_PUT);
		switch(but>>8)
		{
			case LEFT:
			case RIGHT:
				if(x==0)
					x=1;
				else
					x=0;
				break;
			case UP:
				if (y==0)
					y=3;
				else
					y--;
				break;
			case DOWN:
				if (y==3)
					y=0;
				else
					y++;
				break;
		}
		putimage (1+x*130, maxy-42+y*15, image, XOR_PUT);
	}
	while (as!=ENTER);
	formula=x*3+y;
}


void CRoad::def (void)
{
	float x, y;
	gotoxy (1, 25);
	char f[40];
	cout<<"vvedite imia dorogi";
	prfile (f);
	strcpy (filename, f);
	col=nom+1;
	if (col>=4)
		col++;
	if (col>=7)
		col++;
	wrt.open(filename);
	int but, sc;
	x=10;
	y=10;
	putpixel (x, y, 15);
	char as;
	setlinestyle(SOLID_LINE, 1, 2);
	do
	{
		but=bioskey(0);
		sc=but>>8;
		as=but&0x00FF;
		putpixel (x, y, 0);
		arrows2 (sc, as, &x, &y);
		putpixel (x, y, 15);
	}
	while (as!='\15');
	wrt<<x<<"\n"<<y;
	setcolor (col);                    //ASCII-kod klavishi
	do
	{
		but=bioskey(0);
		sc=but>>8;
		as=but&0x00FF;
		wrt<<"\n"<<sc;
		arrows2 (sc, as, &x, &y);
		rectangle (x, y, x+1, y+1);
	}
	while(as!='\15');
	wrt.close();
}

void arrows2 (int sc, char as, float* x, float* y)
{
	switch (as)
			{
				case '\x0':
					switch (sc)
					{
						case LEFT:
							(*x)-=2;
							break;
						case RIGHT:
							(*x)+=2;
							break;
						case UP:
							(*y)-=2;
							break;
						case DOWN:
							(*y)+=2;
							break;
					}
					break;
				case 'q':
					exit(0);
			}
}


void savetown (void)
{
	char pfile2[40];
	gotoxy(1, 1);
	cout<<"input filename\n";
	prfile (pfile2);
	strcpy (pfile, pfile2);
	wrt.open(pfile);
	wrt<<num<<"\n";
	for (int i=0; i<num; i++)
	{
		wrt<<road[i].formula<<"\n";
		wrt<<road[i].a<<"\n";
		wrt<<road[i].b<<"\n";
		wrt<<road[i].c<<"\n";
		wrt<<road[i].n<<"\n";
		wrt<<road[i].t1<<"\n";
		wrt<<road[i].col<<"\n";
		if (road[i].formula==5)
			wrt<<road[i].filename<<"\n";
	}
	wrt<<ns<<"\n";
	for (i=0; i<ns; i++)
	{
		wrt<<svet[i].svet1<<"\n";
		wrt<<svet[i].x<<"\n";
		wrt<<svet[i].y<<"\n";
	}
	wrt.close();
}




void prfile (char pfile1[])
{
	int k=0, i;          //k - flagok na pravilnost' imeni
	while (1)
	{
		cin>>pfile1;
		for (i=0; i<9; i++)
		{
			if (pfile1[i]=='.')     //proverka imeni na nalichie tochki sredi pervyh 9 simvolov
			{
				k=1;
				break;
			}
			if (!isalnum (pfile1[i]))     //proverka na dopustimost' simvolov (mogno bukvy i cifry)
				break;
		}
		if (strlen (pfile1)-i-1>3)         //proverka na dlinu rasshirenia
		{
			cout<<"incorrect name\n";
			continue;
		}
		for (i=i+1; i<strlen (pfile1); i++)
		{
			if (!isalnum (pfile1[i]))     //proverka na dopustimost' simvolov rasshirenia
			{
				 k=0;
				 break;
			}
		}
		if (!k)
		{
			cout<<"incorrect name\n";
			continue;
		}
		break;
	}
}


void redavto (void)
{
	skor1 ();
	police1 ();
	remont1 ();
	cleardevice ();
	gotoxy (1, 1);
	cout<<"insert number of cars";
	cin>>n;
	for (int i=0; i<n; i++)
	{
		cout<<"do you want to create new car or load saved car";
		while (1)
		{
			switch (getch())
			{
				case 'c':
					mash[i].createmash();
					mash[i].save();
					break;
				case 'l':
					mash[i].load();
								break;
				default:
					continue;
			}
			break;
		}
	}
}

void CAvto::createmash (void)
{
	char pfile2[40];
	cout<<"vvedite imia mashiny: ";
	cin>>name;
	cout<<"esli vasha masina legkovaia, vvedite 1, a esli gruzovaia - 0";
	cin>>type;
	cout<<"vvedite maximalnuiu skorost' mashiny ";
	cin>>vmax;
	cout<<"vvedite emkost benzobaka ";
	cin>>benzin;
	cout<<"vvedite cvet mashiny ";
	cin>>col;
	cout<<"input filename\n";
	setcolor(col);
	drawavto ();
	prfile (pfile2);
	strcpy (filename, pfile2);
	unsigned int size;
	size=imagesize(0, 0, 20, 20);
	image=malloc(size);
}

void CAvto::save (void)
{
	wrt.open(filename);
	wrt<<name<<"\n";
	wrt<<type<<"\n";
	wrt<<vmax<<"\n";
	wrt<<benzin<<"\n";
	wrt<<col<<"\n";
	for (int i=0; i<30; i++)
		wrt<<poli[i]<<"\n";
	wrt.close();
}

void CAvto::load (void)
{
	char pfile3[40];
	struct ffblk f;
	int k=-1, i;
	cout<<"\ninput filename\n";
	while (1)
	{
		cin>>pfile3;
		k=findfirst(pfile3, &f, FA_ARCH);       //naiti file s vvedennym imenem
		if (!k)
			break;
		cout<<"such a file is absent\n";
	}
	strcpy (filename, pfile3);
	rd.open (filename);
	rd>>name;
	rd>>type;
	rd>>vmax;
	rd>>benzin;
	rd>>col;
	for (i=0; i<30; i++)
		rd>>poli[i];
	rd.close();
	unsigned int size;
	size=imagesize(0, 0, 20, 20);
	image=malloc(size);
}





void skor1 (void)
{
	skor.nom=0;
	strcpy (skor.name, "03");
	skor.vmax=150;
	skor.benzin=20;
	skor.type=1;
	skor.col=RED;
}

void police1 (void)
{
	police.nom=1;
	strcpy (police.name, "02");
	police.vmax=180;
	police.type=1;
	police.benzin=25;
	police.col=BLUE;
}


void remont1 (void)
{
	remont.nom=2;
	strcpy (remont.name, "01");
	remont.vmax=150;
	remont.type=0;
	remont.benzin=40;
	remont.col=RED;
}

void drawtown (void)
{
	int i;
	for (i=0; i<num; i++)
	{
		road[i].drawroad();
	}
}



void town (void)
{
	int i, c;
	k=0;
	t=0;
	setfillstyle (SOLID_FILL, 7);
	drawtown();
	t=1;
	drawtown();
	drawsvet();
	getch();
	setlinestyle (SOLID_LINE, 1, 1);
	outtextxy (10, maxy-70, "rasstavte mashiny");
	int but, sc;
	char as;
	for (i=0; i<n; i++)
	{
		mash[i].x=10;
		mash[i].y=10;
		c=getpixel (mash[i].x, mash[i].y);
		putpixel (mash[i].x, mash[i].y, 15);
		do
		{
			but=bioskey(0);
			sc=but>>8;
			as=but&0x00FF;
			putpixel (mash[i].x, mash[i].y, c);
			arrows2 (sc, as, &mash[i].x, &mash[i].y);
			moveto (mash[i].x, mash[i].y);
			c=getpixel (mash[i].x, mash[i].y);
			putpixel (mash[i].x, mash[i].y, 15);
		}
		while (as!='\15');
		mash[i].pic();
		mash[i].savepic();
		mash[i].stop=0;
	}
	setfillstyle (SOLID_FILL, 0);
	int i1=0;
	setfillstyle (SOLID_FILL, 0);
	bar (0, maxy-75, maxx, maxy);
	do
	{
		if (i1/10*10==i1)
			svetofor();
		for (i=0; i<n; i++)
		{
			mash[i].loadpic();
			mash[i].dvizhok();
			mash[i].savepic();
			mash[i].draw();
			svet3(i);
		}
		i1++;
		getch();
	}while (1);
}

void CRoad::drawroad (void)
{
	switch (formula)
	{
		case 0:
			priam1();
			break;
		case 1:
			parab1();
			break;
		case 2:
			giperb1();
			break;
		case 3:
			sinus1();
			break;
		case 4:
			lemni1();
			break;
		case 5:
			def1();
			break;
	}
}

void CRoad::priam1(void)
{
	float x, y;
	setcolor (col);
	for (x=-maxx/2; x<maxx/2; x+=0.1)
	{
		y=a*x+b;
		if (k&&(maxy-95)/2-y>0&&(maxy-95)/2-y<maxy-95&&((maxx/2+x-svet[ns-1].x)*(maxx/2+x-svet[ns-1].x)+((maxy-95)/2-y-svet[ns-1].y)*((maxy-95)/2-y-svet[ns-1].y)>400||ns==0))
			redsvet2(maxx/2+x, (maxy-95)/2-y, col);
		if (t)
			rectangle (maxx/2+x, (maxy-95)/2-y, maxx/2+x+1, (maxy-95)/2-y-1);
		else
		{
			setcolor (7);
			fillellipse(maxx/2+x, (maxy-95)/2-y, 8, 8);
		}
	}
}

void CRoad::parab1(void)
{
	double x, y;
	setcolor (col);
	for (x=-maxx/2; x<maxx/2; x+=0.1)
	{
		y=a*(b+x)*(b+x)+c;
		if (k&&((maxy-95)/2-y/4)>0&&((maxy-95)/2-y/4)<maxy-95&&((maxx/2+x-svet[ns-1].x)*(maxx/2+x-svet[ns-1].x)+((maxy-95)/2-y/4-svet[ns-1].y)*((maxy-95)/2-y/4-svet[ns-1].y)>400||ns==0))
			redsvet2(maxx/2+x, (maxy-95)/2-y/4, col);
		if (t)
			rectangle (maxx/2+x, (maxy-95)/2-y/4, maxx/2+x+1, (maxy-95)/2-y/4-1);
		else
		{
			setcolor (7);
			fillellipse(maxx/2+x, (maxy-95)/2-y/4, 8, 8);
		}
	}
}


void CRoad::giperb1(void)
{
	float x, y;
	setcolor (col);
	for (x=-c; x<c; x+=0.1)
	{
		y=sqrt(c*c-x*x);
		if (k&&(maxy-95)/2-y-b>0&&(maxy-95)/2-y-b<maxy-95&&((maxx/2+x+a-svet[ns-1].x)*(maxx/2+x+a-svet[ns-1].x)+((maxy-95)/2-y-b-svet[ns-1].y)*((maxy-95)/2-y-b-svet[ns-1].y)>400||ns==0))
			redsvet2 (maxx/2+x+a, (maxy-95)/2-y-b, col);

		if (t)
			rectangle (maxx/2+x+a, (maxy-95)/2-y-b, maxx/2+x+1+a, (maxy-95)/2-y-b-1);
		else
		{
			setcolor (7);
			fillellipse(maxx/2+x+a, (maxy-95)/2-y-b, 8, 8);
		}
		y=-sqrt(c*c-x*x);
		if (k&&(maxy-95)/2-y-b>0&&(maxy-95)/2-y-b<maxy-95&&((maxx/2+x+a-svet[ns-1].x)*(maxx/2+x+a-svet[ns-1].x)+((maxy-95)/2-y-b-svet[ns-1].y)*((maxy-95)/2-y-b-svet[ns-1].y)>400||ns==0))
			redsvet2(maxx/2+x+a, (maxy-95)/2-y-b, col);
		if (t)
			rectangle (maxx/2+x+a, (maxy-95)/2-y-b, maxx/2+x+1+a, (maxy-95)/2-y-b-1);
		else
		{
			setcolor (7);
			fillellipse(maxx/2+x+a, (maxy-95)/2-y-b, 8, 8);
		}
	}
}

void CRoad::sinus1(void)
{
	double x, y;
	setcolor (col);
	for (x=-maxx/8; x<maxx/8; x+=0.1)
	{
		y=a*sin(n*x+b)+c;
		if (k&&(maxy-95)/2-4*y>0&&(maxy-95)/2-4*y<maxy-95&&((maxx/2+4*x-svet[ns-1].x)*(maxx/2+4*x-svet[ns-1].x)+((maxy-95)/2-4*y-svet[ns-1].y)*((maxy-95)/2-4*y-svet[ns-1].y)>400||ns==0))
			redsvet2(maxx/2+4*x, (maxy-95)/2-4*y, col);
		if (t)
			rectangle (maxx/2+4*x, (maxy-95)/2-4*y, maxx/2+4*x+1, (maxy-95)/2-4*y-1);
		else
		{
			setcolor (7);
			fillellipse(maxx/2+4*x, (maxy-95)/2-4*y, 8, 8);
		}
	}
}

void CRoad::lemni1(void)
{
	double x, y, t, r;
	setcolor (col);
	for (t=-0.785; t<0.785; t+=0.001)
	{
		r=a*sqrt(2*cos(2*t));
		x=r*cos(t);
		y=r*sin(t);
		if (k&&(maxy-95)/2-y-c>0&&(maxy-95)/2-y-c<maxy-95&&((maxx/2+x+b-svet[ns-2].x)*(maxx/2+x+b-svet[ns-2].x)+((maxy-95)/2-y-c-svet[ns-2].y)*((maxy-95)/2-y-c-svet[ns-2].y)>400||ns==0))
			redsvet2 (maxx/2+x+b, (maxy-95)/2-y-c, col);
		if (t)
			rectangle (maxx/2+x+b, (maxy-95)/2-y-c, maxx/2+x+1+b, (maxy-95)/2-y-c-1);
		else
		{
			setcolor (7);
			fillellipse(maxx/2+x+b, (maxy-95)/2-y-c, 8, 8);
		}
		if (k&&(maxy-95)/2+y-c>0&&(maxy-95)/2+y-c<maxy-95&&((maxx/2-x+b-svet[ns-2].x)*(maxx/2-x+b-svet[ns-2].x)+((maxy-95)/2+y-c-svet[ns-2].y)*((maxy-95)/2+y-c-svet[ns-2].y)>400||ns==0))
			redsvet2 (maxx/2-x+b, (maxy-95)/2+y-c, col);
		if (t)
			rectangle (maxx/2-x+b, (maxy-95)/2+y-c, maxx/2-x+1+b, (maxy-95)/2+y-c-1);
		else
		{
			setcolor (7);
			fillellipse(maxx/2-x+b, (maxy-95)/2+y-c, 8, 8);
		}
	}
}

void CRoad::def1 (void)
{
	int x, y, sc;
	rd.open(filename);
	rd>>x;
	rd>>y;
	setcolor (col);                    //ASCII-kod klavishi
	do
	{
		rd>>sc;
		switch (sc)
		{
			case LEFT:
				x-=2;
				break;
			case RIGHT:
				x+=2;
				break;
			case UP:
				y-=2;
				break;
		case DOWN:
				y+=2;
				break;
		}
		if (k&&y>0&&y<maxy-95&&((x-svet[ns-1].x)*(x-svet[ns-1].x)+(y-svet[ns-1].y)*(y-svet[ns-1].y)>400||ns==0))
			redsvet2 (x, y, col);
		if (t)
			rectangle (x, y, x+1, y+1);
		else
		{
			setcolor (7);
			fillellipse(x, y, 8, 8);
		}
	}
	while(!rd.eof());
	rd.close();
}


void redsvet2 (float x, float y, int col)
{
	int c[4];
	c[0]=getpixel(x, y);
	c[1]=getpixel(x+1, y);
	c[2]=getpixel(x+1, y+1);
	c[3]=getpixel(x, y+1);
	if ((c[0]!=0)&&(c[0]!=col)&&(c[0]!=4)||(c[1]!=4)&&(c[1]!=0)&&(c[1]!=col)||(c[2]!=4)&&(c[2]!=0)&&(c[2]!=col)||(c[3]!=4)&&(c[3]!=0)&&(c[3]!=col))
	{
		svet[ns].x=x;
		svet[ns].y=y;
		svet[ns].svet1=col;
		setcolor (4);
		line (svet[ns].x, svet[ns].y, ns*15+10, maxy-85);
		setcolor (col);
		bar (ns*15+10, maxy-95, ns*15+20, maxy-75);
		ns++;
	}

}


void CAvto::dvizhok (void)
{
	int i, kx, ky;
	float v;
	if (((x+vx+10)>=maxx)||((x+vx-10)<=0)||((y+vy)>=(maxy-95))||((y+vy-10)<=0))
	{
		vx=-vx;
		vy=-vy;
	}
	v=sqrt (vx*vx+vy*vy);
	if (vx>=0)
		kx=1;
	else
		kx=-1;
	if (vy>=0)
		ky=1;
	else
		ky=-1;
	if ((((v+1)*30)>vmax)&&(stop!=1))
	{
		v--;
		if (vx*vx>=vy*vy)
		{
			vx-=kx;
			vy=ky*sqrt (v*v-vx*vx);
			v=sqrt (vx*vx+vy*vy);
		}
		else
		{
			vy-=ky;
			vx=kx*sqrt (v*v-vy*vy);
		}
	}
	while (v>=-2&&stop!=1)
	{
		if ((getpixel(x+vx+kx, y+vy+ky)!=0)&&(getpixel(x+vx+kx, y+vy+ky)!=4)&&(getpixel(x+vx+kx, y+vy+ky)!=7)&&(v!=-2))
		{
			vx+=kx;
			vy+=ky;
			v=-2;
		}
		if ((getpixel(x+vx, y+vy+ky)!=0)&&(getpixel(x+vx, y+vy+ky)!=4)&&(getpixel(x+vx, y+vy+ky)!=7)&&(v!=-2))
		{
			vy+=ky;
			v=-2;
		}
		if ((getpixel(x+vx+kx, y+vy)!=0)&&(getpixel(x+vx+kx, y+vy)!=4)&&(getpixel(x+vx+kx, y+vy)!=7)&&(v!=-2))
		{
			vx+=kx;
			v=-2;
		}
		if ((getpixel(x+vx-kx, y+vy+ky)!=0)&&(getpixel(x+vx-kx, y+vy+ky)!=4)&&(getpixel(x+vx-kx, y+vy+ky)!=7)&&(v!=-2))
		{
			vx-=kx;
			vy+=ky;
			v=-2;
		}
		if ((getpixel(x+vx, y+vy)!=0)&&(getpixel(x+vx, y+vy)!=4)&&(getpixel(x+vx, y+vy)!=7)&&(v!=0)&&(v!=-2))
			v=-2;
		if ((getpixel(x+vx+kx, y+vy-ky)!=0)&&(getpixel(x+vx+kx, y+vy-ky)!=4)&&(getpixel(x+vx+kx, y+vy-ky)!=7)&&(v!=-2))
		{
			vx+=kx;
			vy-=ky;
			v=-2;
		}
		if ((getpixel(x+vx-kx, y+vy)!=0)&&(getpixel(x+vx-kx, y+vy)!=4)&&(getpixel(x+vx-kx, y+vy)!=7)&&(v!=-2))
		{
			vx-=kx;
			v=-2;
		}
		if ((getpixel(x+vx, y+vy-ky)!=0)&&(getpixel(x+vx, y+vy-ky)!=4)&&(getpixel(x+vx, y+vy-ky)!=7)&&(v!=-2))
		{
			vy-=ky;
			v=-2;
		}
		if ((getpixel(x+vx-kx, y+vy-ky)!=0)&&(getpixel(x+vx-kx, y+vy-ky)!=4)&&(getpixel(x+vx-kx, y+vy-ky)!=7)&&(v!=-2))
		{
			vx-=kx;
			vy-=kx;
			v=-2;
		}
		v-=2;
		if (v>-2)
		{
			if (vx*vx>=vy*vy)
			{
				vx-=2*kx;
				vy=kx*sqrt (v*v-vx*vx);
				v=sqrt (vx*vx+vy*vy);
			}
			else
			{
				vy-=2*kx;
				vx=kx*sqrt (v*v-vy*vy);
				v=sqrt (vx*vx+vy*vy);
			}
		}
	}
	if (getpixel(x+vx, y+vy)!=0)
	{
		x+=vx;
		y+=vy;
		col2=getpixel (x+vx, y+vy);
	}
}





void CAvto::drawavto (void)
{
	cleardevice ();
	int i, n=14;
	int sc, but;
	char as;
	gotoxy (1, 1);
	cout<<"narisuite mashinu po kletochkam";
	for (i=0; i<16; i++)
	{
		line (i*6+5, 30, i*6+5, 30+15*6);
		line (5, i*6+30, 5+15*6, i*6+30);
	}
	setcolor (col);
	for (i=0; i<n; i++)
	{
		poli[i*2]=-16;
		poli[i*2+1]=-16;
		putpixel (poli[i*2]*3+8+8*6, poli[i*2+1]*3+30+8*6, 15);
		do
		{
			but=bioskey(0);
			sc=but>>8;
			as=but&0x00FF;
			putpixel (poli[i*2]*3+8+8*6, poli[i*2+1]*3+33+8*6, 0);
			arrows2 (sc, as, &poli[i*2], &poli[i*2+1]);
			putpixel (poli[i*2]*3+8+8*6, poli[i*2+1]*3+33+8*6, 15);
		}
		while (as!='\15');
		if (!i)
			moveto (poli[i*2]*3+8+8*6, poli[i*2+1]*3+33+8*6);
		else
			lineto (poli[i*2]*3+8+8*6, poli[i*2+1]*3+33+8*6);
		if (poli[2]==poli[0]&&poli[3]==poli[1])
			i=1;
		if (getch()=='y')
			n=i;
	}
	i++;
	poli[i*2]=poli[0];
	poli[i*2+1]=poli[1];
	lineto (poli[i*2]*3+8+8*6, poli[i*2+1]*3+33+8*6);
	getch();
}

void CAvto::pic (void)
{
	unsigned int size;                  //razmer bufera dlia risunka
	size=imagesize(1, 1, 19, 19);    //rasmer kursora
	image=malloc(size);
}

void CAvto::savepic (void)
{
	getimage (x-9, y-9, x+9, y+9, image);
}

void CAvto::loadpic (void)
{
	putimage (x-9, y-9, image, COPY_PUT);
}

void CAvto::draw (void)
{
	int i;
	float t;
	float r, t2, x2, y2,x1, y1, v, cos, sin;
	setcolor (col);
	v=sqrt (vx*vx+vy*vy);
	sin=vy/v;
	cos=vx/v;
	for (i=0; i<15; i++)
	{
		x2=poli[2*i]/2;
		y2=poli[2*i+1]/2;
		x1=x2*cos-y2*sin;
		y1=x2*sin+y2*cos;
		if (i==0)
			moveto (x+x1, y+y1);
		else
		{
			lineto (x+x1, y+y1);
			if (poli[2*i]==poli[0]&&poli[2*i+1]==poli[1]&&i>1)
				i=15;
		}
	}
}

void svetofor (void)
{
	int i;
	if (ns!=0)
	{
		i=svet[0].svet2&1;
		svet[0].svet2=!i;
		setfillstyle (SOLID_FILL, (svet[0].svet2&1)*2+2);
		fillellipse (15, maxy-80, 5, 5);
		for (i=1; i<ns; i++)
		{
			svet[i].svet2=!svet[i-1].svet2;
			setfillstyle (SOLID_FILL, (svet[i].svet2&1)*2+2);
			fillellipse (i*15+15, maxy-80, 5, 5);
		}
	}
}


void drawsvet (void)
{
	int i;
	setlinestyle (DOTTED_LINE, 1, 1);
	for (i=0; i<ns; i++)
	{
		setcolor (4);
		line (svet[i].x, svet[i].y, i*15+10, maxy-85);
		setfillstyle(SOLID_FILL, DARKGRAY);
		bar (i*15+10, maxy-95, i*15+20, maxy-75);
		setcolor (svet[i].svet1);
		rectangle (i*15+10, maxy-95, i*15+20, maxy-75);
	}
}

void svet3 (int t)
{
	int i, n1, k, k1, x, y;
	for (i=0; i<ns; i++)
	{
		k=svet[i].x;
		k1=svet[i].y;
		x=mash[t].x;
		y=mash[t].y;
		if (((x+mash[t].vx-k)*(x+mash[t].vx-k)+(y+mash[t].vy-k1)*(y+mash[t].vy-k1))<226)
		{
			n1=i;
			i=ns;
		}
		else
			n1=-1;
	}
	if (n1!=-1&&ns!=0)
	{
		if (svet[n1].svet1==mash[t].col2)
			mash[t].stop=svet[n1].svet2;
		else
			mash[t].stop=!(svet[n1].svet2&1);
	}
	else
		mash[t].stop=0;
}

/*void CAvto::benz5 (void)
{
	benzin-=sqrt(vx*vx+vy*vy)/(type+1);
}

void CAvto::data (int k)
{
	int x1=10, y1;
	int v;
	char str[10];
	setfillstyle (SOLID_FILL, 0);
	bar (x1+k*40, maxy-75, x1+k*40+40, maxy);
	setcolor (col);
	outtextxy (x1+k*40, maxy-70, name);
	v=sqrt(vx*vx+vy*vy);
	itoa (v, str, 4);
	outtextxy (x1+k*40, maxy-60, "v ");
	outtextxy (x1+15+k*40, maxy-60, str);
} */